<?
/*
Datenpunkte auszulesen mit der Funktion
HMXML_getParamSet_VALUES()

HM-CC-VG-1 - Kanal 0

	 [UPDATE_PENDING] =>
    [RSSI_DEVICE] => -65535
    [AES_KEY] => 0
    [DEVICE_IN_BOOTLOADER] =>
    [UNREACH] =>
    [CONFIG_PENDING] =>
    [LOWBAT] =>
    [STICKY_UNREACH] =>
    [INHIBIT] =>
    [RSSI_PEER] => -54

HM-CC-VG-1 - Kanal 1

	 [PARTY_STOP_MONTH] => 1
    [CONTROL_MODE] => 1
    [PARTY_STOP_DAY] => 1
    [BOOST_MODE] => true
    [ACTUAL_HUMIDITY] => 62
    [PARTY_START_DAY] => 1
    [PARTY_TEMPERATURE] => 5
    [AUTO_MODE] => true
    [SET_TEMPERATURE] => 12
    [PARTY_START_MONTH] => 1
    [MANU_MODE] => 20.0
    [ACTUAL_TEMPERATURE] => 22.3
    [PARTY_STOP_YEAR] => 0
    [PARTY_MODE_SUBMIT] =>
    [COMFORT_MODE] => true
    [PARTY_STOP_TIME] => 0
    [PARTY_START_YEAR] => 0
    [PARTY_START_TIME] => 0
    [LOWERING_MODE] => true

*/

include "hmxml.inc.php";

$HM_Cache_ID = @IPS_GetVariableIDByName("HM_Device_Cache", $GLOBALS['hmxml_ID']);

//************************************************************
//HMCache auf den letzten Stand bringen, nur ntig, falls Neue Gruppen hinzugefgt wurden.
//HMXML_DevicesCache_update(0);  // 0= alle Devices; 1= nur HM WD und HM RF an CCU 2; 2= nur HM_VG's XMLRPC an CCU2-Port 9292/groups
//************************************************************

IPS_SetScriptTimer ( $_IPS['SELF'], 120 );

$All_HM=HMXML_DevicesCache_list();
$HM_VGs=HMXML_DevicesCache_ListByType('HM-CC-VG-1');



If ($_IPS['SENDER'] == "Execute")  // manuelles Ausfhren zur Instalation
	{
	foreach ($HM_VGs as $HMAddress => $VG)  // Jede HM_VG - prfen
		{
		Foreach ($VG as $key => $Kanal)
		   {
		   If (@IPS_ObjectExists($Kanal['IPS_ID']) ==! true) // Wenn noch keine IPS-ID vorhanden
		      {
				$IPS_ID=SetDummyByIdent($_IPS['SELF'], $Kanal['Type']." - ".$HMAddress.":".$key, "HMVG".$HMAddress."x".$key, 0);
				$All_HM['HM-CC-VG-1'][$HMAddress][$key]['IPS_ID']=$IPS_ID; // neue ID in Cache schreiben
		      SetValue($HM_Cache_ID, serialize($All_HM));
				}
				else
				{
				$IPS_ID=$Kanal['IPS_ID']; // bereits vorhandene ID aus Cache holen[IPS_ID]
				}
				$params = HMXML_getParamSet_VALUES($HMAddress, $key);
				Foreach ($params as $ValueName => $parm)
				         {
				         switch ($ValueName)
								{
							   case "UPDATE_PENDING":
								case "DEVICE_IN_BOOTLOADER":
								case "STICKY_UNREACH":
								case "INHIBIT":
								case "CONFIG_PENDING":
								case "UNREACH":
								case "BOOST_MODE":
								case "AUTO_MODE":
								case "COMFORT_MODE":
								case "LOWERING_MODE":

		  				        $ID=CreateVariableByIdent($IPS_ID, $ValueName, 0, "", $ValueName, 1);  // Boolean
						        SetValue($ID,$parm);
							     break;

								case "LOWBAT":
						        $ID=CreateVariableByIdent($IPS_ID, $ValueName, 0, "~Battery", $ValueName, 1);  // Boolean
								  SetValue($ID,$parm);
							     break;

								case "RSSI_PEER":
						      case "RSSI_DEVICE":
							   case "PARTY_STOP_YEAR":
						      case "PARTY_STOP_MONTH":
						      case "PARTY_STOP_DAY":
							   case "PARTY_STOP_TIME":
							   case "PARTY_START_YEAR":
							   case "PARTY_START_MONTH":
						      case "PARTY_START_DAY":
							   case "PARTY_START_TIME":
                          $ID=CreateVariableByIdent($IPS_ID, $ValueName, 1, "", $ValueName, 1);  // Integer
								  SetValue($ID,$parm);
                          break;
                          
                        case "CONTROL_MODE":
                          $ID=CreateVariableByIdent($IPS_ID, $ValueName, 1, "HM_Heizung_Steuerung_RT-DN", $ValueName, 1, $_IPS['SELF']);  // Integer
								  SetValue($ID,$parm);
                          break;

								case "ACTUAL_HUMIDITY":
                          $ID=CreateVariableByIdent($IPS_ID, $ValueName, 2, "~Humidity.F", $ValueName, 1);  // Float
								  SetValue($ID,$parm);
                          break;

								case "ACTUAL_TEMPERATURE":
								case "MANU_MODE":
								case "PARTY_TEMPERATURE":
								  $ID=CreateVariableByIdent($IPS_ID, $ValueName, 2, "~Temperature", $ValueName, 1);  // Float
								  SetValue($ID,$parm);
                          break;

								case "SET_TEMPERATURE":
								  $ID=CreateVariableByIdent($IPS_ID, $ValueName, 2, "~Temperature.HM", $ValueName, 1, $_IPS['SELF']);  // Float
								  SetValue($ID,$parm);
                          break;


								case "PARTY_MODE_SUBMIT":
								  $ID=CreateVariableByIdent($IPS_ID, $ValueName, 3, "", $ValueName, 1);  // String
								  SetValue($ID,$parm);
                          break;

                    		}
							}
			}
	   }
	}

If ($_IPS['SENDER'] == 'WebFront' or $_IPS['SENDER'] == 'Variable') // Ausfhrung erfolgt ber WebFrond oder Variablennderung
	{
	// ****************************
	// Aktion fr Variable Modus
	// ****************************

	$ParentID=IPS_GetObject ($_IPS['VARIABLE'])['ParentID'];
   $HMAddress= substr(IPS_GetObject ($ParentID)['ObjectIdent'], 4, 10); // Parent-Ident lautet: HMVG".$HMAddress."x".$key
   $HM_Kanal = substr(IPS_GetObject ($ParentID)['ObjectIdent'], -1, 1);
	   

	if (IPS_GetObject ($_IPS['VARIABLE'])['ObjectIdent'] == 'CONTROL_MODE') // Die Variable CONTROL_MODE wurde gendert
					{
					Switch ($_IPS['VALUE'])
						   {
						   case -1:
                         HMXML_setParamFloat_VALUES($HMAddress, "MANU_MODE", 100, $channel=1); // Sommermodus
                         SetValue($_IPS['VARIABLE'], $_IPS['VALUE']);
				         	 break;
						   case 0:
                         HMXML_setParamBolean_VALUES($HMAddress, "AUTO_MODE", true, $channel=1); // Automodus
                         SetValue($_IPS['VARIABLE'], $_IPS['VALUE']);
						       break;
						   case 1:
								 $temp= GetValue(IPS_GetObjectIDByIdent ("SET_TEMPERATURE", $ParentID));
								 HMXML_setParamFloat_VALUES($HMAddress, "MANU_MODE", $temp, $channel=1); // Manuell
								 SetValue($_IPS['VARIABLE'], $_IPS['VALUE']);
						       break;
		   				case 3:
                         HMXML_setParamBolean_VALUES($HMAddress, "BOOST_MODE", true, $channel=1); // Boostmodus
                         SetValue($_IPS['VARIABLE'], $_IPS['VALUE']);
						       break;
							}
					}
					
	if (IPS_GetObject ($_IPS['VARIABLE'])['ObjectIdent'] == 'SET_TEMPERATURE')
					{
					HMXML_setParamFloat_VALUES($HMAddress, "SET_TEMPERATURE", $_IPS['VALUE'], $channel=1);

               If (GetValue(IPS_GetObjectIDByIdent ("CONTROL_MODE", $ParentID)) == 1) // ist manuelle Steuerung aktiviert;
						{
						HMXML_setParamFloat_VALUES($HMAddress, "MANU_MODE", $_IPS['VALUE'], $channel=1); // Manuell
                 	SetValue(IPS_GetObjectIDByIdent ("MANU_MODE", $ParentID), $_IPS['VALUE']);
						}
					SetValue($_IPS['VARIABLE'], $_IPS['VALUE']);
					}
		}



If ($_IPS['SENDER'] == "TimerEvent") // Ausfhrung ber Timerevent
	{
	foreach ($HM_VGs as $HMAddress => $VG)  // Jede HM_VG - prfen
		{
		Foreach ($VG as $key => $Kanal)
		   {
		   If (@IPS_ObjectExists($Kanal['IPS_ID']) == true) // Wenn noch keine IPS-ID vorhanden
		      {
		      $IPS_ID=$Kanal['IPS_ID']; // bereits vorhandene ID aus Cache holen[IPS_ID]
				$params = HMXML_getParamSet_VALUES($HMAddress, $key);

				Foreach ($params as $ValueName => $parm)
				         {
				         $ID=@IPS_GetObjectIDByIdent ($ValueName, $Kanal['IPS_ID']);
							If ($ID ==! false)
							   {
								SetValue($ID,$parm);
								}
                   	}

		      }
		    }
		 }
	 }


/**************************
    Variable anlegen
***************************/

//0	Legt eine Variable vom Typ Boolean an
//1	Legt eine Variable vom Typ Integer an
//2	Legt eine Variable vom Typ Float an
//3	Legt eine Variable vom Typ String an


function CreateVariableByIdent($parentID, $name, $type, $profile, $ident, $position, $aktion="")
    {
        $vid = @IPS_GetObjectIDByIdent($ident, $parentID);
        if($vid === false)
        {
            $vid = IPS_CreateVariable($type);
            IPS_SetParent($vid, $parentID);
            IPS_SetName($vid, $name);
				IPS_SetPosition ($vid, $position);
            IPS_SetInfo($vid, "this variable was created by script #".$_IPS['SELF']);
            if($profile !== "") { IPS_SetVariableCustomProfile($vid, $profile); }
				if($ident !=="") {IPS_SetIdent ($vid , $ident );}
				if($aktion !=="") {IPS_SetVariableCustomAction($vid, $_IPS['SELF']);}
			}
	  	  return $vid;
    }


/**************************
    Kategorie anlegen
***************************/
function SetKatByIdent($parentID, $name, $ident, $position)
    {
	 $kid = @IPS_GetObjectIDByIdent ($ident, $parentID );
	 if($kid === false)
        {
			$kid = IPS_CreateCategory ( );       //Kategorie anlegen
			IPS_SetName($kid, $name); 		//Kategorie benennen
			IPS_SetParent($kid, $parentID);
         IPS_SetPosition ($kid, $position);
         if($ident !=="") {IPS_SetIdent ($kid , $ident );}
		  }
    return $kid;
	 }

/**************************
   Dummy anlegen
***************************/
function SetDummyByIdent($parentID, $name, $ident, $position)
    {
	 $Iid = @IPS_GetObjectIDByIdent($ident, $parentID );
	 if($Iid === false)
        {
			$Iid=IPS_CreateInstance("{485D0419-BE97-4548-AA9C-C083EB82E61E}"); // Dummy anlegen
			IPS_SetName($Iid, $name);
			IPS_SetParent($Iid, $parentID);
         IPS_SetPosition ($Iid, $position);
         if($ident !=="") {IPS_SetIdent ($Iid, $ident);}
		  }
    return $Iid;
	 }

?>
